/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32A6700
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "gpio_demo.h"
#include "uart_demo.h"
#include "dma_demo.h"
#include "adc_demo.h"


/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
extern uint32_t   g_AdcIntTaken;

uint16_t get_value1[256];



int main()
{
    uint32_t msCnt;     // count value of 1ms

    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);


    Uart0_Init(19200);


    /*the adc result is outputed by dma repeat mode  */
    Dma_Adc_Config(DMA_VECTOR_ADC, DMA_Mode_Repeat, (uint16_t *)&ADC->ADCR, get_value1, 256);
    Adc_Init();
    ADC_Start(ADC_Channel_2);

    while (1)
    {
        while (g_AdcIntTaken < 1);

        g_AdcIntTaken = 0;
        printf("ADCR = 0x%04X\n", get_value1[0]);
    }

}




