/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32A6700
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "dma_demo.h"
#include "adc_demo.h"
#include "interval_demo.h"



/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
extern uint32_t   g_AdcIntTaken;

uint16_t get_value[8 * 2];


int main()
{
    uint32_t msCnt;     // count value of 1ms
    int i = 0;
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);

    Uart0_Init(19200);

    /*the adc hardwareTriggerNoWait test(use interval timer trigger ADC convertor)*/
    printf("Hello, UART\n");
    Interval_Init(IT_FIL, 10000);
    IT_Start();

    Adc_HardNoWait_Init();
    //  ADC_Set_HardTrigger(ADC_ExternalTrig_Hardware_NoWait, ADC_HardwareTrig_INTIT);
    ADC_Start(ADC_Channel_2);
    Dma_Adc_Config(DMA_VECTOR_ADC, DMA_Mode_Normal, (uint16_t *)&ADC->ADCR, get_value, 8);


    while (g_AdcIntTaken < 1);

    for (i = 0; i < 8; i++)
    {
        printf("ADC Get Value = 0x%04X\n", get_value[i]);
    }

    IT_Stop();
    ADC_Stop();

}




