/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32A6700
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "adc_demo.h"
#include "delay_demo.h"


/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
extern uint32_t   g_AdcIntTaken;

uint16_t get_value[8*2];


int main()
{
    uint32_t msCnt;     // count value of 1ms
    uint32_t tempAdc;
    int i = 0;
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
    delay_init(SystemCoreClock);
    Uart0_Init(19200);


    /*the adc sample result and output average result every 8 times*/
    Adc_Init();
    tempAdc = ADC_Converse(ADC_Channel_2, 8, get_value);

    for (i = 0; i < 8; i++)
    {
        printf("ADC Get Value = 0x%04X\n", get_value[i]);
    }

    printf("ADC Avg Value = 0x%04X\n", tempAdc);

    while (1)
    {
        delayMS(1000);
        tempAdc = ADC_Converse(ADC_Channel_2, 8, get_value);
        printf("ADC Avg Value = 0x%04X\n", tempAdc);
    }

}



