#include "can_demo.h"
#include "gpio.h"
#include "can.h"
#include "isr.h"




static void can_error_handler()
{
	INTC_ClearPendingIRQ(CAN0ERR_IRQn);
	
	CANErr_Recover(CAN0);
}


void CAN_Port_Config(void)
{
	GPIO_InitTypeDef	GPIO_InitStruct;
	CAN_InitTypeDef		CAN_InitStruct;

	/* GPIO AF set for CAN bus */
	GPIO_PinAFConfig(GPIO_PORT0, GPIO_Pin_0, GPIO_P00, GROUP_AF_ODEFAULT);
	GPIO_PinAFConfig(GPIO_PORT0, GPIO_Pin_1, GPIO_P01, GROUP_AF_ODEFAULT);

	
	/****** GPIO for CAN bus init ******/
	/* CTXD pin init */
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0 ;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
	GPIO_InitStruct.GPIO_Level  = GPIO_Level_HIGH;
	GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT0, &GPIO_InitStruct);
	
	/* CRXD pin init */
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_1 ;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
	GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT0, &GPIO_InitStruct);

	/****** GPIO for STB init ******/
	GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
	GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
	GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
	GPIO_InitStruct.GPIO_PuPd   = GPIO_PuPd_DOWN;
	GPIO_InitStruct.GPIO_Level  = GPIO_Level_LOW;
	GPIO_Init(GPIO_PORT12, &GPIO_InitStruct);
	
	/****** CAN bus periphal init ******/
	CAN_InitStruct.CAN_Prescaler = 2; //32M/2=16MHz
	CAN_InitStruct.CAN_BitRatePrescaler = 2;//16MHz/2 = 8MHz
	CAN_InitStruct.CAN_SJW = CAN_SJW_1tq;  //ͬ
	CAN_InitStruct.CAN_BS1 = CAN_BS1_14tq; //+λ1
	CAN_InitStruct.CAN_BS2 = CAN_BS2_1tq;  //λ2 8MHZ/16 = 500Kbps
	CAN_InitStruct.CAN_OperateMode = CAN_OpMode_Initial;
	CAN_InitStruct.MASK1 = 0x1fffffffU;
	CAN_InitStruct.MASK2 = 0x1fffffffU;
	CAN_InitStruct.MASK3 = 0x1fffffffU;
	CAN_InitStruct.MASK4 = 0x1fffffffU;
	CAN_Init(CAN0, &CAN_InitStruct);
	
	CAN_ITConfig(CAN0, CAN_IT_ERR_STATE | CAN_IT_ERR_PROTO, ENABLE);//enable error interrupt
	
	ISR_Register(CAN0ERR_IRQn, can_error_handler);	
}
