/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32A6700
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "flash.h"
#include <easyflash.h>

//洢ṹ
#define USER_ENV_NAME			"ENV"

/* ⱨֵĬϸߵ޶ */
#define USER_DEF_SPO2_H			(100)	//Ѫ
#define USER_DEF_SPO2_L			(90)	//Ѫ
#define USER_DEF_SBP_H			(140)	//ѹ
#define USER_DEF_SBP_L			(120)	//ѹ
#define USER_DEF_DBP_H			(90)	//ѹ
#define USER_DEF_DBP_L			(80)	//ѹ
#define USER_DEF_HR_H			(150)	//ʸ
#define USER_DEF_HR_L			(60)	//ʵ
#define USER_DEF_HEALTH_TOL		(20)

#pragma pack(1)
//ʱȡݽṹ嶨
struct UserRtc_DateFormat {
	unsigned char hsys;
	unsigned char isam;
    unsigned char sec;
    unsigned char min;
    unsigned char hour;
    unsigned char day;
    unsigned char week;
    unsigned char month;
    unsigned char year;
};
//ݽṹԶ
typedef struct UserHealth_Env_DataFormat {
	unsigned char swble;			//
	unsigned char swvoice;			//
	
	char peermac[13];				//MAC
	
	struct UserRtc_DateFormat date;
	
	struct Health_Data {
		struct DataLimit {
			unsigned char set;
			unsigned char lower;
			unsigned char upper;
		} l, h;
	} sbp, dbp, hr, spo2;
} UserHealth_Env_t;
#pragma pack()


/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
UserHealth_Env_t user_health_env;

void user_health_env_load(void)
{
	ef_get_env_blob(USER_ENV_NAME, &user_health_env, sizeof(user_health_env), NULL);
}



void user_health_env_set_default(void)
{
	/* Ĭϼ໤ֵ */
	user_health_env.sbp.l.set	= USER_DEF_SBP_L;
	user_health_env.sbp.l.lower = USER_DEF_SBP_L - USER_DEF_HEALTH_TOL;
	user_health_env.sbp.l.upper	= USER_DEF_SBP_L + USER_DEF_HEALTH_TOL;
	user_health_env.sbp.h.set	= USER_DEF_SBP_H;
	user_health_env.sbp.h.lower = USER_DEF_SBP_H - USER_DEF_HEALTH_TOL;
	user_health_env.sbp.h.upper	= USER_DEF_SBP_H + USER_DEF_HEALTH_TOL;
	user_health_env.dbp.l.set	= USER_DEF_DBP_L;
	user_health_env.dbp.l.lower = USER_DEF_DBP_L - USER_DEF_HEALTH_TOL;
	user_health_env.dbp.l.upper	= USER_DEF_DBP_L + USER_DEF_HEALTH_TOL;
	user_health_env.dbp.h.set	= USER_DEF_DBP_H;
	user_health_env.dbp.h.lower = USER_DEF_DBP_H - USER_DEF_HEALTH_TOL;
	user_health_env.dbp.h.upper	= USER_DEF_DBP_H + USER_DEF_HEALTH_TOL;
	user_health_env.spo2.l.set	= USER_DEF_SPO2_L;
	user_health_env.spo2.l.lower= USER_DEF_SPO2_L - USER_DEF_HEALTH_TOL;
	user_health_env.spo2.l.upper= USER_DEF_SPO2_L + USER_DEF_HEALTH_TOL;
	user_health_env.spo2.h.set	= USER_DEF_SPO2_H;
	user_health_env.spo2.h.lower= USER_DEF_SPO2_H - USER_DEF_HEALTH_TOL;
	user_health_env.spo2.h.upper= USER_DEF_SPO2_H + USER_DEF_HEALTH_TOL;
	user_health_env.hr.l.set	= USER_DEF_HR_L;
	user_health_env.hr.l.lower	= USER_DEF_HR_L - USER_DEF_HEALTH_TOL;
	user_health_env.hr.l.upper	= USER_DEF_HR_L + USER_DEF_HEALTH_TOL;
	user_health_env.hr.h.set	= USER_DEF_HR_H;
	user_health_env.hr.h.lower	= USER_DEF_HR_H - USER_DEF_HEALTH_TOL;
	user_health_env.hr.h.upper	= USER_DEF_HR_H + USER_DEF_HEALTH_TOL;
	
	/* Ĭʱ */
	user_health_env.date.year	= 23;
	user_health_env.date.month	= 9;
	user_health_env.date.day	= 05;
	user_health_env.date.hour	= 0;
	user_health_env.date.min	= 0;
	user_health_env.date.sec	= 0;
	user_health_env.date.week	= 0;
	user_health_env.date.hsys	= 0;
	user_health_env.date.isam	= 0;
	
	/* ĬϿ */
	user_health_env.swble = 0;
	user_health_env.swvoice = 0;
	
	/* 浽flash */
	ef_set_env_blob(USER_ENV_NAME, &user_health_env, sizeof(user_health_env));
}

int main()
{
    uint32_t msCnt; // count value of 1ms
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
	
    Uart0_Init(19200);
	/* flashʼ */
    if (easyflash_init() != EF_NO_ERR) {
		return 0;
    }
	
	/* ȡ洢Ļ */
	user_health_env_load();
	uint8_t is_zero = 1;
	for (int i = 0; i < sizeof(user_health_env); i++) {
		if (((char*)&user_health_env)[i] != 0) {
			is_zero = 0;
			break;
		}
	}
	printf("user_health_env data year=%d \r\n",user_health_env.date.year);
	if (is_zero) {
		user_health_env_set_default();
	}	

}


