/*******************************************************************************
*                  COPYRIGHT (C) 2021 CMS Technologies Ltd.                    *
*                                                                              *
********************************************************************************
* FileName      : iic_demo.c                                                   *
* Author        :                                                              *
* Version       : 1.0                                                          *
* Date          : 2021.08.13                                                   *
* Description   :                                                              *
* Function List :                                                              *
********************************************************************************/
#include "iic_demo.h"
static IIC_FRAME_t pData; /*pData used as an example,user can dinfine different paramater according to needs*/

volatile uint8_t g_iic_tx_end;                /* iic send data end */
volatile uint8_t g_iic_rx_end;                /* iic receive data end */
volatile uint16_t g_iic_rx_count = 0;
int8_t Iic00_Init(void)
{
    int8_t res ;
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    I2C_InitTypeDef  IIC_InitStructure = {0};

    GPIO_PinAFConfig(GPIO_PORT3, GPIO_Pin_0, GPIO_P30, GROUP_AF_ODEFAULT); //SCL00 allocated to default pins 
    GPIO_PinAFConfig(GPIO_PORT5, GPIO_Pin_0, GPIO_P50, GROUP_AF_ODEFAULT); //SDA00 allocated to default pins

    /*SCL00 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT3, &GPIO_InitStruct);

    /*SDA00 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT5, &GPIO_InitStruct);

    IIC_InitStructure.I2C_ClockSpeed = 400000;
    res = I2C_Init(I2C00, &IIC_InitStructure);

    if (res)
    {
        SCI_ERROR_LOG(res);
        return res;
    }

    //  ISR_Register(IIC00_IRQn,iic00_interrupt); //жϷ·ע
    return SCI_SUCCESS;
}
int8_t Iic01_Init(void)
{
    int8_t res ;
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    I2C_InitTypeDef  IIC_InitStructure = {0};

    GPIO_PinAFConfig(GPIO_PORT7, GPIO_Pin_5, GPIO_P75, GROUP_AF_ODEFAULT); //P75 default function SCL01
    GPIO_PinAFConfig(GPIO_PORT7, GPIO_Pin_4, GPIO_P74, GROUP_AF_ODEFAULT); //P74 default function SDA01

    /*SCL01 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_5;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT7, &GPIO_InitStruct);

    /*SDA01 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_4;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT7, &GPIO_InitStruct);

    IIC_InitStructure.I2C_ClockSpeed = 400000;
    res = I2C_Init(I2C01, &IIC_InitStructure);

    if (res)
    {
        SCI_ERROR_LOG(res);
        return res;
    }

    //  ISR_Register(IIC01_IRQn,iic01_interrupt); //жϷ·ע

    return SCI_SUCCESS;
}


int8_t Iic11_Init(void)
{
    int8_t res ;
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    I2C_InitTypeDef  IIC_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_0, GPIO_P10, GROUP_AF_ODEFAULT); //P10  default function SCL11
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_1, GPIO_P11, GROUP_AF_ODEFAULT); //P10  default function SDA11

    /*SCL11 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    /*SDA11 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_1;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);


    IIC_InitStructure.I2C_ClockSpeed = 400000;
    res = I2C_Init(I2C11, &IIC_InitStructure);

    if (res)
    {
        SCI_ERROR_LOG(res);
        return res;
    }

    //  ISR_Register(IIC11_IRQn,iic11_interrupt); //жϷ·ע

    return SCI_SUCCESS;
}

/***********************************************************************************************************************
* Function Name: Iic20_Init
* @brief  iic20 init
* @param
* @return error or success
***********************************************************************************************************************/
int8_t Iic20_Init(void)
{
    int8_t res ;
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    I2C_InitTypeDef  IIC_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_5, GPIO_P15, GROUP_AF_ODEFAULT); //SCL20 to any desired pins with PxxCFG register
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_4, GPIO_P14, GROUP_AF_ODEFAULT); // SDA20 desired to

    /*SCL20 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_5;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    /*SDA20 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_4;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_OD;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    IIC_InitStructure.I2C_ClockSpeed = 200000;   //iicٶ

    res = I2C_Init(I2C20, &IIC_InitStructure);

    if (res)
    {
        SCI_ERROR_LOG(res);
        return res;
    }

#ifdef IIC_USING_INTERRUPT
    ISR_Register(IIC20_IRQn, iic20_interrupt);   //жϷ·ע
#endif
    return SCI_SUCCESS;
}




/***********************************************************************************************************************
* Function Name: Iic_Write
* @brief  This function starts transferring data for IIC in master mode.
* @param  adr - set address for select slave
* @param  tx_buf - transfer buffer pointer
* @param  tx_num - buffer size
* @return None
***********************************************************************************************************************/
void Iic20_Write(uint8_t address, uint8_t *tx_buf, uint16_t tx_num)
{
    pData.flag = IIC_INT_IDLE;
    address &= 0xFE;    //iic write flag

    I2C_Set_TransmitMode(I2C20, I2C_TransmitMode_Send);
    I2C_GenerateSTART(I2C20);

    INTC_ClearPendingIRQ(IIC20_IRQn); // clear INTIIC01 interrupt flag
    NVIC_ClearPendingIRQ(IIC20_IRQn); // clear INTIIC01 interrupt flag
    INTC_EnableIRQ(IIC20_IRQn);     // enable INTIIC01 interrupt flag
    NVIC_SetPriority(IIC20_IRQn, 3);  /* low priority */

    I2C_SendByte(I2C20, address);

    g_iic_tx_end = 0;
    pData.flag = IIC_INT_TX;
    pData.data = tx_buf;    //send buffer pointer
    pData.len  = tx_num;    //set send data count
}
/***********************************************************************************************************************
* Function Name: Iic_Read
* @brief  This function starts receiving data for IIC in master mode.
* @param  adr - set address for select slave
* @param  rx_buf - receive buffer pointer
* @param  rx_num - buffer size
* @return None
***********************************************************************************************************************/
void Iic20_Read(uint8_t address, uint8_t *rx_buf, uint16_t rx_num)
{
    pData.flag = IIC_INT_IDLE;
    address |= 0x01;    //iic read flag

    I2C_Set_TransmitMode(I2C20, I2C_TransmitMode_Send);
    I2C_GenerateSTART(I2C20);

    INTC_ClearPendingIRQ(IIC20_IRQn); // clear INTIIC01 interrupt flag
    NVIC_ClearPendingIRQ(IIC20_IRQn); // clear INTIIC01 interrupt flag
    INTC_EnableIRQ(IIC20_IRQn);     // enable INTIIC01 interrupt flag

    I2C_SendByte(I2C20, address);

    g_iic_rx_end = 0;
    g_iic_rx_count = 0;
    pData.flag = IIC_INT_RX;
    pData.data = rx_buf;    //send buffer pointer
    pData.len  = rx_num;    //set send data count
}

static void iic_callback_master_error(uint8_t flag)
{
    /* Start user code. Do not edit comment generated here */
    /* End user code. Do not edit comment generated here */
}



void iic20_interrupt(void)
{
    IIC_FRAME_t *pFrame = &pData;


    if ((I2C_GetErrStaus(I2C20, I2C_FLAG_NOACK) == SET) && (pFrame->len != 0))   //(I2C_GetErrStaus(I2C20, I2C_FLAG_NOACK) == SET)
    {
        iic_callback_master_error(IIC_NO_ACK); // NO IIC ACK is received
    }
    else if ((I2C_GetErrStaus(I2C20, I2C_FLAG_OVERRUN) == SET)  && (pFrame->len != 0))
    {
        iic_callback_master_error(IIC_OVF_RUN);
    }
    else/* IIC ACK is received*/
    {
        /* Control for master send */
        if (pFrame->flag == IIC_INT_TX)
        {
            if (pFrame->len > 0U)
            {
                I2C_SendByte(I2C20, *pFrame->data);
                pFrame->data++;
                pFrame->len--;
            }
            else //IIC01 finishes master transmission
            {
                I2C_GenerateSTOP(I2C20);
                g_iic_tx_end = 1;
                pFrame->flag = 0;
            }
        }
        else  // Control for master receive
        {
            if ((pFrame->flag & SCI_IIC_SENDADR) == 0)
            {
                I2C_ChannelStart_Cmd(I2C20, DISABLE);       //رͨ
                I2C_Set_TransmitMode(I2C20, I2C_TransmitMode_Recv);//Ϊ
                I2C_ChannelStart_Cmd(I2C20, ENABLE);        //ͨ

                pFrame->flag |= SCI_IIC_SENDADR;

                if (pFrame->len == 1)
                {
                    I2C_Output_Cmd(I2C20, DISABLE);  //ͨ
                }

                I2C_SendByte(I2C20, 0xFFU);
            }
            else
            {
                if (g_iic_rx_count < pFrame->len)
                {
                    *pFrame->data = I2C_ReceiveByte(I2C20);
                    pFrame->data++;
                    g_iic_rx_count++;

                    if (g_iic_rx_count == (pFrame->len - 1))
                    {
                        I2C_Output_Cmd(I2C20, DISABLE);
                        I2C_SendByte(I2C20, 0xFFU);
                    }
                    else if (g_iic_rx_count == pFrame->len)
                    {
                        I2C_GenerateSTOP(I2C20);
                        g_iic_rx_end = 1;
                    }
                    else
                    {
                        I2C_SendByte(I2C20, 0xFFU);
                    }
                }
            }
        }
    }

    INTC_ClearPendingIRQ(IIC20_IRQn);
}
