/*******************************************************************************
*                  COPYRIGHT (C) 2021 CMS Technologies Ltd.                    *
*                                                                              *
********************************************************************************
* FileName      : spi_demo.c                                                 *
* Author        :                                                              *
* Version       : 1.0                                                          *
* Date          : 2021.08.13                                                   *
* Description   :                                                              *
* Function List :                                                              *
********************************************************************************/
#include "spi_demo.h"
#include "dma_demo.h"
static SSPI_FRAME_t pData; /*pData used as an example,user can dinfine different paramater according to needs*/

volatile uint8_t *gp_spi00_rx_address;       /* spi00 receive buffer address */
volatile uint16_t g_spi00_rx_length;         /* spi00 receive data length */
volatile uint16_t g_spi00_rx_count;          /* spi00 receive data count */
volatile uint8_t *gp_spi00_tx_address;       /* spi00 send buffer address */
volatile uint16_t g_spi00_tx_length;         /* spi00 send data length */
volatile uint16_t g_spi00_tx_count;          /* spi00 send data count */

void NSS_set()
{
    GPIO_SetBits(GPIO_PORT6, GPIO_Pin_2);
}
void NSS_clr()
{
    GPIO_ResetBits(GPIO_PORT6, GPIO_Pin_2);
}
/***********************************************************************************************************************
* Function Name: Spi0_Init
* @brief simple spi init
* @param
* @return  status
***********************************************************************************************************************/
int8_t Spi00_Slave_Init(void)
{
    int8_t res;
    GPIO_InitTypeDef GPIO_InitStruct;
    SPI_InitTypeDef  SPI_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT6, GPIO_Pin_2, GPIO_P62, GROUP_AF_ODEFAULT); //SS00 can be disired to any pins GROUP_AF_SS00
    GPIO_PinAFConfig(GPIO_PORT3, GPIO_Pin_0, GPIO_P30, GROUP_AF_ODEFAULT); // SCLK_OUTPUT can be disired to any pins
    GPIO_PinAFConfig(GPIO_PORT5, GPIO_Pin_1, GPIO_P51, GROUP_AF_ODEFAULT); // MOSI(SDO00) can be disired to any pins
    GPIO_PinAFConfig(GPIO_PORT5, GPIO_Pin_0, GPIO_P50, GROUP_AF_ODEFAULT); // MSIO(SDI00) can be disired to any pins

    /*SS GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_2;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_PuPd    = GPIO_PuPd_UP;
    GPIO_Init(GPIO_PORT6, &GPIO_InitStruct);

    /*SCLK GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT3, &GPIO_InitStruct);

    /*SDO(MOSI) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_1;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT5, &GPIO_InitStruct);

    /*SDI(MIS0) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT5, &GPIO_InitStruct);

    SPI_InitStructure.SPI_Mode = SPI_Mode_Slave;                   //SPIģʽ:ΪSPI ģʽSLAVE
    SPI_InitStructure.SPI_DataSize = SPI_Data_Bits_8;       //SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_Phase_Mode = SPI_Phase_Mode0;     //ѡʹspiĹģʽ
    SPI_InitStructure.SPI_Bitorder = SPI_Bit_Msb;          //ѡbitȴ

    res = SSPI_Init(SSPI00, &SPI_InitStructure);

    ISR_Register(SPI00_IRQn, spi00_interrupt);       //жϷ·ע
    NSS.Active = NSS_clr;                            //NSSƬѡʼ
    NSS.Inactive = NSS_set;
    NSS.Inactive();                                  //NSSʼ״̬ MODE0 µ͵ƽΪУclkһز

    if (res)
    {
        return res;
    }

    return SCI_SUCCESS;
}


int8_t Spi11_Slave_Init(void)
{
    int8_t res;
    GPIO_InitTypeDef GPIO_InitStruct;
    SPI_InitTypeDef  SPI_InitStructure;
	
    GPIO_PinAFConfig(GPIO_PORT6, GPIO_Pin_2, GPIO_P62, GROUP_AF_ODEFAULT); //SS00 can be disired to any pins GROUP_AF_SS00
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_0, GPIO_P10, GROUP_AF_ODEFAULT); // SCLK11_INPUT default fuction with P10
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_2, GPIO_P12, GROUP_AF_ODEFAULT); // MOSI(SDO11) default fuction with P12
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_1, GPIO_P11, GROUP_AF_ODEFAULT); // MSIO(SDI11) default fuction with P11

    /*SS GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_2;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_PuPd    = GPIO_PuPd_UP;
    GPIO_Init(GPIO_PORT6, &GPIO_InitStruct);

    /*SCLK GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    /*SDO(MOSI) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_2;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    /*SDI(MIS0) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_1;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    SPI_InitStructure.SPI_Mode = SPI_Mode_Slave;                   //SPIģʽ:ΪSPI ģʽSLAVE
    SPI_InitStructure.SPI_DataSize = SPI_Data_Bits_8;             //SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_Phase_Mode = SPI_Phase_Mode0;          //ѡʹspiĹģʽ
    SPI_InitStructure.SPI_Bitorder = SPI_Bit_Msb;              //ѡbitȴ

    res = SSPI_Init(SSPI11, &SPI_InitStructure);

    if (res)
    {
        return res;
    }

    //  ISR_Register(SPI11_IRQn, spi11_interrupt);       //жϷ·ע

    NSS.Active = NSS_clr;                             //NSSƬѡʼ
    NSS.Inactive = NSS_set;
    NSS.Inactive();                                  //NSSʼ״̬ MODE0 µ͵ƽΪУclkһز
    return SCI_SUCCESS;
}

int8_t Spi20_Slave_Init(void)
{
    int8_t res;
    GPIO_InitTypeDef GPIO_InitStruct;
    SPI_InitTypeDef  SPI_InitStructure;

    GPIO_PinAFConfig(GPIO_PORT6, GPIO_Pin_3, GPIO_P63, GROUP_AF_ODEFAULT); //SS00 can be disired to any pins GROUP_AF_SS00	
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_5, GPIO_P15, GROUP_AF_ODEFAULT); // SCLK20_INPUT can be disired to any pins with PxxCFG register
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_3, GPIO_P13, GROUP_AF_ODEFAULT); //  MOSI(SDO20)  can be disired to any pins with PxxCFG register
    GPIO_PinAFConfig(GPIO_PORT1, GPIO_Pin_4, GPIO_P14, GROUP_AF_ODEFAULT); //  MSIO(SDI20) can be disired to any pins with SDI20PCFG register

    /*SS GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_3;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_PuPd    = GPIO_PuPd_UP;
    GPIO_Init(GPIO_PORT6, &GPIO_InitStruct);

    /*SCLK GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_5;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    /*SDO(MOSI) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin     = GPIO_Pin_3;
    GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Ctrl    = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    /*SDI(MIS0) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_4;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT1, &GPIO_InitStruct);

    SPI_InitStructure.SPI_Mode = SPI_Mode_Slave;                   //SPIģʽ:ΪSPI ģʽSLAVE
    SPI_InitStructure.SPI_DataSize = SPI_Data_Bits_8;             //SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_Phase_Mode = SPI_Phase_Mode0;          //ѡʹspiĹģʽ
    SPI_InitStructure.SPI_Bitorder = SPI_Bit_Msb;              //ѡbitȴ

    res = SSPI_Init(SSPI20, &SPI_InitStructure);

    if (res)
    {
        return res;
    }

    //  ISR_Register(SPI20_IRQn, spi20_interrupt);       //жϷ·ע

    return SCI_SUCCESS;
}

/***********************************************************************************************************************
* Function Name: Spi_Write
* @brief  spi write data
* @param  None
* @return None
***********************************************************************************************************************/
void Spi00_Write(uint8_t tx_data)
{
    SSPI_SendByte(SSPI00, tx_data);
}

/***********************************************************************************************************************
* Function Name: Spi_Read
* @brief  spi read data
* @param  None
* @return None
***********************************************************************************************************************/
uint8_t Spi00_Read(SCIAFSelect_TypeDef func)
{
    return SSPI_ReceiveByte(SSPI00);
}

/***********************************************************************************************************************
* Function Name: Spi_Int_Write
* @brief  spi write data by interrupt,it can be used in the condition of master write or slave write
* @param  None
* @return None
***********************************************************************************************************************/
void Spi00_Int_Write(uint8_t *tx_buf, uint16_t tx_num)
{
    SSPI_Set_TransmitMode(SSPI00, SSPI_TransmitMode_Send);
    SSPI_Start(SSPI00);
    INTC_EnableIRQ(SPI00_IRQn);

    pData.data = tx_buf;    //send buffer pointer
    pData.len  = tx_num;  //set send data count
    pData.flag = SSPI_INT_TX;   //set data direction
    INTC_SetPendingIRQ(SPI00_IRQn);
}

/***********************************************************************************************************************
* Function Name: Spi_Int_Read
* @brief  spi read data by interrupt,it can be used in the condition of master write or slave write
* @param  None
* @return None
***********************************************************************************************************************/
void Spi00_Int_Read(uint8_t *rx_buf, uint16_t rx_num)
{
    SSPI_Set_TransmitMode(SSPI00, SSPI_TransmitMode_Recv);
    SSPI_Start(SSPI00);

    INTC_EnableIRQ(SPI00_IRQn);

    pData.data = rx_buf;   //read buffer pointer
    pData.len  = rx_num;   //set receive data count
    pData.flag = SSPI_INT_RX;   //set data direction
    SSPI_SendByte(SSPI00, 0xFF); //user can use SIO to trigger interrupt
}

/***********************************************************************************************************************
* Function Name: Spi_Dma_Write
* @brief  spi write data by dma
* @param  None
* @return None
***********************************************************************************************************************/
void Spi00_Slave_Dma_Write(uint8_t *tx_buf, uint16_t tx_num)
{
    SSPI_Set_TransmitMode(SSPI00, SSPI_TransmitMode_Send);
    SSPI_Start(SSPI00);
    INTC_EnableIRQ(SPI00_IRQn);
#if 1
    DMA_Sspi_Slave_Write(DMA_VECTOR_SPI00, CTRL_DATA_SPI00, DMA_Mode_Normal, tx_buf, (void *)&SSPI00_SDR, tx_num); //config dma transmission

    pData.flag = SSPI_INT_DMA;   //set data direction
    DMA_Trigger(DMA_VECTOR_SPI00);
#else
    /*if you want to use interrput to trigger dma*/
    DMA_Sspi_Slave_Write(DMA_VECTOR_SPI00, CTRL_DATA_SPI00, DMA_Mode_Normal, tx_buf + 1, (void *)&SSPI00_SDR, tx_num - 1); //config dma transmission
    SSPI_SendByte(SSPI00, tx_buf[0]);
    tx_buf++ ;

    pData.data = tx_buf;    //send buffer pointer
    pData.len  = 0;  //set send data count
    pData.flag = INT_TX;   //set data direction
#endif
}

/***********************************************************************************************************************
* Function Name: Spi_Dma_Read
* @brief  spi read data by dma
* @param  None
* @return None
***********************************************************************************************************************/

void Spi00_Slave_Dma_Read(uint8_t *rx_buf, uint16_t rx_num)
{
    static uint8_t dummy_sio11 = 0xFFU;

    SSPI_Set_TransmitMode(SSPI00, SSPI_TransmitMode_Recv);
    SSPI_Start(SSPI00);
    INTC_EnableIRQ(SPI00_IRQn);

    DMA_Sspi_Slave_Read(DMA_VECTOR_SPI00, CTRL_DATA_SPI00, DMA_Mode_Normal, (void *)&SSPI00_SDR, rx_buf, rx_num); //config dma transmission

    SSPI_SendByte(SSPI00, dummy_sio11);
    pData.flag = SSPI_INT_DMA;   //set data direction
}

/***********************************************************************************************************************
* Function Name: spi_callback_error
* @brief  UART0 Receive interrupt service routine
* @param  None
* @return None
***********************************************************************************************************************/
void spi_callback_error()
{
    //user edit here when appear error
}

/***********************************************************************************************************************
* Function Name: spi0_interrupt
* @brief  spi write/read interrupt service routine
* @param  None
* @return None
***********************************************************************************************************************/
void spi00_interrupt(void)
{
    volatile uint8_t err_type;
    volatile uint8_t sio_dummy;
    SSPI_FRAME_t *pFrame = &pData;
    SCIAFSelect_TypeDef func = SSPI00;

    err_type = SSPI_GetErrStaus(SSPI00, SSPI_FLAG_OVERRUN);
    SCI_ClearFlag(SSPI00, err_type);

    INTC_ClearPendingIRQ(SPI00_IRQn);


    if (1U == err_type)
    {
        spi_callback_error();//error condition
    }
    else
    {
        if (pFrame->flag == SSPI_INT_TX)
        {
            if (pFrame->len > 0)
            {
                if (0U != pFrame->data)
                {
                    SSPI_SendByte(SSPI00, *pFrame->data);
                    pFrame->data++;
                    pFrame->len--;
                }
            }
            else
            {
                if (0U != pFrame->data)
                {
                    if ((SSPI_Get_MasterMode(SSPI00) != SPI_Mode_Master) && (SSPI_Get_TransmitMode(SSPI00) != SSPI_TransmitMode_Recv))//slave mode :sclk is inputed by master clk
                    {
                        ;// when in slave mode ,do not need to wait end
                    }
                    else
                    {
                        while (SSPI_GetErrStaus(SSPI00, SCI_UNDER_EXECUTE)); //waitting conmunction end, if register ST turns 1,or SS turns 1
                    }
                }

                SSPI_Stop(func);
                g_spi_tx_end = 1;
            }
        }

        if (pFrame->flag == SSPI_INT_RX)
        {
            if (pFrame->len > 1)
            {
                if (0U != pFrame->data)
                {
                    *pFrame->data = SSPI_ReceiveByte(SSPI00);
                    pFrame->data++;
                    pFrame->len--;
                }
                else
                {
                    sio_dummy = SSPI_ReceiveByte(SSPI00);
                }

                if (SSPI_Get_MasterMode(SSPI00) == SPI_Mode_Master)
                {
                    SSPI_SendByte(SSPI00, 0xFF);                   // dummy write in master reception mode
                }
            }
            else if (pFrame->len == 1)
            {

                while (SSPI_GetErrStaus(SSPI00, SCI_VALID_STORED) == 0); // wait last data stored in register SDR

                if (0U != pFrame->data)
                {
                    *pFrame->data = SSPI_ReceiveByte(SSPI00);
                    pFrame->len--;
                }
                else
                {
                    sio_dummy = SSPI_ReceiveByte(SSPI00);
                }

                SSPI_Stop(func);
                g_spi_rx_end = 1;
            }
        }

        if (pFrame->flag == SSPI_INT_DMA)
        {
            g_spi_tx_end = 1;
            g_spi_rx_end = 1;
        }
    }
}


