/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32A6700
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "gpio_demo.h"
#include "uart_demo.h"
#include "tim_demo.h"
#include "delay_demo.h"


/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
uint16_t get_value[8 * 2];


int main()
{
    uint32_t msCnt;     // count value of 1ms

    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
    delay_init(SystemCoreClock);
	Gpio_Init();

    Uart0_Init(19200);

    extern uint32_t g_Int_Taken;
    /*Example3:P17 connnect to P00,Tim4 count external event, when 10 pulses are captured, g_Int_Taken will increase 1*/
    Tim40_EventCount();
	TIM_Start(TM40,TIM_Index_Channel0);

    while (1)
    {
        GPIO_SetBits(GPIO_PORT1, GPIO_Pin_7);
        GPIO_SetBits(GPIO_PORT1, GPIO_Pin_6);
        delayMS(50);
        GPIO_ResetBits(GPIO_PORT1, GPIO_Pin_7);
        GPIO_ResetBits(GPIO_PORT1, GPIO_Pin_6);
        delayMS(50);
        printf("g_Int_Taken= %d\n", g_Int_Taken);
    }
}



