/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32A6700
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "gpio_demo.h"
#include "uart_demo.h"
#include "tim_demo.h"
#include "delay_demo.h"


/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/

int main()
{
    uint32_t msCnt;     // count value of 1ms
    uint32_t width = 0;
	float time = 0;
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
    delay_init(SystemCoreClock);

    Uart0_Init(19200);

    /*Example4:Tim41 get external wave pluse widthpulse period*/
    Tim40_GetPulsePeriod_Init();
	TIM_Start(TM40,TIM_Index_Channel0);
	
	while(1)
	{
		width = TIM_GetPulsePeriod(TM40,TIM_Index_Channel0);
		printf("P00/TI00 pulse width  = %d fCLK\n", width);  /* expected value: msCnt */	
	}


}




